local FRACUNIT = FRACUNIT
local TICRATE = TICRATE

-- Got this neat little idea from Tyron's Fast Respawn

addHook("ThinkFrame", function()
	if not hq_superform.value then return end
	for p in players.iterate
		if not (p.mo and p.mo.valid) then continue end
		if p.spectator then continue end
		p.hqsuperflash = $ or 0
		p.hqsuperflash = max($-1, 0)
		p.lastsupercheck = $ or false
		
		if HQ_SuperCheck(p)
		and HQ_SuperCheck(p) ~= p.lastsupercheck
			p.hqsuperflash = 10
			S_StartSound(nil, sfx_s3k9f, p)
		end
		
		p.lastsupercheck = HQ_SuperCheck(p)
	end
end)

hud.add(function(v, p, c)
	if not p.hqsuperflash then return end
	v.fadeScreen(SKINCOLOR_WHITE, min(10, max(p.hqsuperflash, 0)))
end)