-------------------------------------------------------------|
---------------HUGE QUEST by RetroStation--------------------|
----------------------and DarkyBenji-------------------------|
-------------------------------------------------------------|
freeslot(
	"sfx_hq",
	"sfx_hqa"
)
sfxinfo[sfx_hq] = {
	flags = SF_X4AWAYSOUND
}
sfxinfo[sfx_hqa]= {
	flags = SF_X4AWAYSOUND
}

rawset(_G, "HugeQuest", "Rev. Mona PTR") -- Heyo!

---------|
--CVars--|
---------|

rawset(_G, "hq_debug" , CV_RegisterVar({
	name = "hq_debug",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_huge" , CV_RegisterVar({
	name = "hq_huge",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL,
	PossibleValue = CV_OnOff,
	func = function(var)
		if not var.value then
			if (hq_superform.value) then
				print("Both Grow+ and Invincibility+ must be enabled to use Super Forms.")
				if server then
					COM_BufInsertText(server, "hq_superform off")
				end
			end
		end
	end
}))

rawset(_G, "hq_extralarge" , CV_RegisterVar({ -- Big McLarge Huge
	name = "hq_extralarge",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_offroad" , CV_RegisterVar({
	name = "hq_offroad",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_mtstore" , CV_RegisterVar({
	name = "hq_mtstore",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "hq_sparkle" , CV_RegisterVar({
	name = "hq_sparkle",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL,
	PossibleValue = CV_OnOff,
	func = function(var)
		if not var.value then
			if (hq_superform.value) then
				print("Both Grow+ and Invincibility+ must be enabled to use Super Forms.")
				if server then
					COM_BufInsertText(server, "hq_superform off")
				end
			end
		end
	end
}))

rawset(_G, "hq_superform" , CV_RegisterVar({
	name = "hq_superform",
	defaultvalue = "On",
	flags = CV_NETVAR|CV_CALL,
	PossibleValue = CV_OnOff,
	func = function(var)
		if var.value then
			if not (hq_huge.value and hq_sparkle.value) then
				print("Both Grow+ and Invincibility+ must be enabled to use Super Forms.")
				if server then
					COM_BufInsertText(server, "hq_superform off")
				end
			end
		end
	end
}))

rawset(_G, "hq_supercolor" , CV_RegisterVar({
	name = "hq_supercolor",
	defaultvalue = "-1",
	flags = 0,
	PossibleValue = {MIN = -1, MAX = 8}
}))

----------------|
--FUCKING PAIN--|
----------------|


local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
--local ANGLE_22h = ANGLE_22h
--local FRACBITS = FRACBITS
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_driftcharge = k_driftcharge
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_boostpower = k_boostpower
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_offroad = k_offroad
local k_itemroulette = k_itemroulette
local k_roulettetype = k_roulettetype
local STARTTIME = 6*TICRATE + (3*TICRATE/4)
local pks

rawset(_G, "growplus", {speedmod = FRACUNIT/10, timer = (15*TICRATE)})

--Init------|
----And-----|
------Sync--|

local function hq_init(p)
	p.huge = 0 -- New Grow timer
	p.hqspeen = false
	p.hqboom = false
	p.hqspb = false
	p.hqgstacks = 0 -- How many times you've stacked Grow
	p.hqsupershift = 1 -- Animated Super glow
	--prev tics
	p.HQLFitem = 0
	p.HQLFamount = 0
end

addHook("PlayerSpawn", hq_init)
------------|
------------|
------------|

local function hq_ingame()
	local count = 0
	for p in players.iterate
		if (p and p.valid) and not p.spectator then
			count = $+1
		end
	end
	return count
end

local function GrowplusEndCheck(p)
	if p.huge == 1 
	or p.playerstate ~= PST_LIVE 
	or p.pflags & PF_TIMEOVER
	or (p.kartstuff[k_invincibilitytimer] == 0 and p.kartstuff[k_growshrinktimer] < 0) 
	or p.exiting then
		return true
	else 
		return false 
	end
end

-- Modded HUD are cluttered as is, and "Terrain Immune" in previous builds didn't scale 
-- well at low resolutions like 320x200. Also, fuck HUD code. Also ensures both Huge and 
-- Sparkle timers are in sync for the Super state.
local function HQ_PowerEnd(p)
	if hq_superform.value
		if p.huge > 0
		and (p.kartstuff[k_invincibilitytimer] > 0 or (hq_sparkle.value and p.mo.sparkle > 0)) then
			if hq_sparkle.value
				if p.huge ~= p.mo.sparkle then
					p.huge = p.mo.sparkle
				end
			else
				if p.huge ~= p.kartstuff[k_invincibilitytimer] then
					p.huge = p.kartstuff[k_invincibilitytimer]
				end
			end
		end
	end
	if ((p.huge > 5*TICRATE)
	or (p.kartstuff[k_invincibilitytimer] > 5*TICRATE)) then
		return
	elseif ((p.huge > 0 and p.huge > 3*TICRATE and p.huge <= 5*TICRATE)
	or (p.kartstuff[k_invincibilitytimer] > 0 and p.kartstuff[k_invincibilitytimer] > 3*TICRATE and p.kartstuff[k_invincibilitytimer] <= 5*TICRATE)) then
		if leveltime%2 == 0 then
			local cloud = P_SpawnMobj(p.mo.x, p.mo.y, (p.mo.z + p.mo.height), MT_WIPEOUTTRAIL)
			cloud.fuse = 8
			cloud.color = SKINCOLOR_WHITE
			cloud.colorized = true
		end
		
	elseif ((p.huge > 0 and p.huge <= 3*TICRATE)
	or (p.kartstuff[k_invincibilitytimer] > 0 and p.kartstuff[k_invincibilitytimer] <= 3*TICRATE)) then
		if not ((p.huge%TICRATE) or (p.kartstuff[k_invincibilitytimer]%TICRATE)) then
			if not (HOSTMOD and (CV_FindVar("powersound").value))
				S_StartSound(p.mo, sfx_alarm)
			end
			--print(p.kartstuff[k_invincibilitytimer].."/"..p.mo.sparkle)
		end
		
		if not HQ_SuperCheck(p)
		and not (HOSTMOD and CV_FindVar("powerflash").value)
			if (p.huge > 0 and leveltime % 5 == 0)
			or (p.kartstuff[k_invincibilitytimer] > 0 and leveltime % 5 == 0) then
				p.mo.color = SKINCOLOR_RED
				p.mo.colorized = true
			else
				p.mo.color = p.skincolor
				p.mo.colorized = false
			end
		end

		if leveltime%2 == 0 then
			local cloud = P_SpawnMobj(p.mo.x, p.mo.y, (p.mo.z + p.mo.height), MT_WIPEOUTTRAIL)
			cloud.fuse = 8
			cloud.color = SKINCOLOR_RED
			cloud.colorized = true
		end
	end
end

local function HQ_PowerTimerEnd(p)
	if ((p.huge > 0 and p.huge <= 3*TICRATE)
	or (p.kartstuff[k_invincibilitytimer] > 0 and p.kartstuff[k_invincibilitytimer] <= 3*TICRATE)) then
		return true
	end
	return false
end

rawset(_G, "HQ_SuperCheck", function(p)
	if (p.huge and p.huge > 1)
	and p.kartstuff[k_invincibilitytimer] > 1 then
		return true
	end
	return false
end)

local function buildTimeString(x)
	if x == nil or x == 99999999 then return "N/A" end
	return (""..string.format("%02d", G_TicsToMinutes(x)).."'"..string.format("%02d", G_TicsToSeconds(x)).."\34"..string.format("%02d", G_TicsToCentiseconds(x)))
end

--- Music Transition block for new Invincibility and Grow ---
addHook("MusicChange", function(oldmusic, newmusic, flags, looping)
	//print("oldmusic:"..oldmusic.."  newmusic:"..newmusic)
	
	for dp in displayplayers.iterate
		//print("Huge:"..dp.huge.." Sparkle:"..dp.kartstuff[k_invincibilitytimer])
		if GrowplusEndCheck(dp) then continue end
		if (dp.huge and dp.huge > 1) and dp.kartstuff[k_invincibilitytimer] <= 1 //What do you mean the music stop at 1?!
			if not (newmusic == "kgrow")
				return "kgrow", flags, true
			end
		end
		
		if ((dp.huge and dp.huge > 1) or dp.kartstuff[k_growshrinktimer] > 0)
		and dp.kartstuff[k_invincibilitytimer] > 1
		and hq_superform.value then
			if ((newmusic == "kgrow") or (newmusic == "kinvnc"))
			or ((oldmusic == "kgrow") or (oldmusic == "kinvnc"))
				return "hqsupr", flags, true
			end
		end
		
		if HQ_SuperCheck(dp)
			if oldmusic == "hqsupr"
			and (newmusic ~= "hqsuper")
				return true
			end
		end
	end
end)

--- Grow Reconstruction: Base code by Benji, balance adjustments by RetroStation--- 
local function K_HugeQuest(p)
	if not (hq_huge.value) then return end
	
	pks = p.kartstuff
	if pks[k_growshrinktimer] > 0
		if JUICEBOX
			p.JBlastgst = 0
		end
		if (battleplus and G_BattleGametype())
			p.huge = growplus.timer+1
			--Grow+ doesn't stack in BattlePlus to prevent cheese in modes 
			--like Emerald Thief
		else
			if p.huge > 0
			and p.hqgstacks >= 2
				p.huge = (($+(growplus.timer+1))*3)/4		
			else
				p.huge = $+(growplus.timer+1)
			end
			
			if hq_superform.value -- Activate Super Form
			and p.mo.sparkle
				p.huge = max(($+p.mo.sparkle)/2, 10*TICRATE)
				p.huge = min($, 10*TICRATE)
				p.mo.sparkle = p.huge
			end
		end

		p.hqgstacks = $+1

		pks[k_growshrinktimer] = 0
		//print("timer:"..p.huge)
		//print("HUGE QUEST")
	end

	if p.huge > 1 
	and not p.exiting then
		p.huge = max($-(hq_ingame()/pks[k_position]), 1) -- Decays faster in better positions
		if HQ_SuperCheck(p)
		and hq_extralarge.value then
			p.mo.destscale = 2*mapobjectscale
			if not pks[k_sneakertimer]
			and pks[k_speedboost] > 0 then
				pks[k_speedboost] = min($, (FRACUNIT/8))
			end
		else
			pks[k_speedboost] = max($, growplus.speedmod)
		end
		
		pks[k_accelboost] = max($, (3*FRACUNIT)/2)

		if hq_offroad.value then
			pks[k_offroad] = 0
			pks[k_boostpower] = max($, FRACUNIT)

			if S_SoundPlaying(p.mo, sfx_cdfm70) --delete offroad sound
				S_StopSoundByID(p.mo, sfx_cdfm70)
			end
		end
				
		if pks[k_hyudorotimer]
			pks[k_hyudorotimer] = 0
			p.powers[pw_flashing] = 0 
			if kmp != nil 
			and kmp_extendflashtics.value then 
				p.mo.K_fakeflashing = 0
			end //lol KartMP
		end

		if HQ_SuperCheck(p)
			if hq_supercolor.value == -1 then
				if p.mo.skin == "sonic"
					p.mo.color = HQ_animSuper[0][p.hqsupershift]
					if leveltime%5 == 0 then
						if p.hqsupershift == #HQ_animSuper[0]
							p.hqsupershift = 1
						else
							p.hqsupershift = $ + 1
						end
					end
				elseif (p.mo.skin == "tails" or p.mo.skin == "kuze") -- Kuze: Heat Mode
					p.mo.color = HQ_animSuper[1][p.hqsupershift]
					if leveltime%5 == 0 then
						if p.hqsupershift == #HQ_animSuper[1]
							p.hqsupershift = 1
						else
							p.hqsupershift = $ + 1
						end
					end
				elseif p.mo.skin == "knuckles"
					p.mo.color = HQ_animSuper[2][p.hqsupershift]
					if leveltime%5 == 0 then
						if p.hqsupershift == #HQ_animSuper[2]
							p.hqsupershift = 1
						else
							p.hqsupershift = $ + 1
						end
					end
				elseif (p.mo.skin == "blaze" or p.mo.skin == "majima") -- Majima: Legend Heat Mode
					p.mo.color = HQ_animSuper[3][p.hqsupershift]
					if leveltime%5 == 0 then
						if p.hqsupershift == #HQ_animSuper[3]
							p.hqsupershift = 1
						else
							p.hqsupershift = $ + 1
						end
					end
				elseif (p.mo.skin == "gunvolt" or p.mo.skin == "copen") -- Anthem
					p.mo.color = HQ_animSuper[5][p.hqsupershift]
					if leveltime%5 == 0 then
						if p.hqsupershift == #HQ_animSuper[5]
							p.hqsupershift = 1
						else
							p.hqsupershift = $ + 1
						end
					end
				elseif p.mo.skin == "kiryu" -- Climax Heat Mode
					p.mo.color = HQ_animSuper[2][p.hqsupershift]
					if leveltime%5 == 0 then
						if p.hqsupershift == #HQ_animSuper[2]
							p.hqsupershift = 1
						else
							p.hqsupershift = $ + 1
						end
					end
				else
					p.mo.color = HQ_animSuper[0][p.hqsupershift]
					if leveltime%5 == 0 then
						if p.hqsupershift == #HQ_animSuper[0]
							p.hqsupershift = 1
						else
							p.hqsupershift = $ + 1
						end
					end
				end
			else
				p.mo.color = HQ_animSuper[hq_supercolor.value][p.hqsupershift]
				if leveltime%5 == 0 then
					if p.hqsupershift == #HQ_animSuper[hq_supercolor.value]
						p.hqsupershift = 1
					else
						p.hqsupershift = $ + 1
					end
				end
			end
			--print(p.mo.color)
			p.mo.colorized = false
		else
			if not HQ_PowerTimerEnd(p) then
				if not pks[k_invincibilitytimer]
				and not (BoostFX)
					if p.huge%(TICRATE/7) == 0 
						if hq_offroad.value then
							p.mo.color = SKINCOLOR_BYZANTIUM
						else
							p.mo.color = SKINCOLOR_PERIWINKLE
						end
						p.mo.colorized = true
					else
						p.mo.color = p.skincolor
						p.mo.colorized = false
					end
				elseif not pks[k_invincibilitytimer]
				and (BoostFX and p.bfxflamecolor < 103)
					if p.huge%(TICRATE/7) == 0
						if hq_offroad.value then 
							p.mo.color = SKINCOLOR_BYZANTIUM
						else
							p.mo.color = SKINCOLOR_PERIWINKLE
						end
						p.mo.colorized = true
					else
						p.mo.color = p.skincolor
						p.mo.colorized = false
					end
				end
			end
		end

		if pks[k_roulettetype] == 2
			pks[k_roulettetype] = 1
		end

		if pks[k_itemblink] == TICRATE
			if pks[k_itemtype] == 1 then 
				pks[k_itemtype] = 6 end
			if pks[k_itemtype] == 5 then
				pks[k_itemtype] = 8 end
			if pks[k_itemtype] == 2 then
				pks[k_itemtype] = 3 end
			if pks[k_itemtype] == 14 then 
				if P_RandomChance(FRACUNIT/10)
					pks[k_itemtype] = 16
				else
					if P_RandomChance(FRACUNIT/2)
						pks[k_itemtype] = 6
						pks[k_itemamount] = 4
					else
						pks[k_itemtype] = 4
						pks[k_itemamount] = 10				
					end
				end
			end
		end
	end
		
	if p.huge > 0 and GrowplusEndCheck(p) then
		p.mo.colorized = false
		p.mo.color = p.skincolor
		p.mo.scalespeed = mapobjectscale/TICRATE
		p.mo.destscale = mapobjectscale
		P_RestoreMusic(p)
		pks[k_growshrinktimer] = 0
		p.huge = 0
		p.hqgstacks = 0
	end
end

--Offroad dust? Fuck that.
local function HQ_NoDust(mo)
	if not (hq_offroad.value) then return end
	if not (mo and mo.valid) return end
	if not (mo.target and mo.target.valid) return end
	if mo.target.player.huge
		mo.flags2 = $ | MF2_DONTDRAW
	else
		mo.flags2 = $ & ~MF2_DONTDRAW
	end
end
addHook("MobjThinker", HQ_NoDust, MT_WIPEOUTTRAIL)

--Friction? Fuck that.
local function HQ_NoGlue(mo)
	if not (hq_huge.value) return end
	if not (mo and mo.valid and mo.player) return end
	if leveltime < TICRATE return end
	//if leveltime >= 236
		//print(mo.friction)
	//end
	if mo.player.huge
		mo.friction = max($, 62914)
	end
end
addHook("MobjThinker", HQ_NoGlue, MT_PLAYER)


--Pipes? Thwomps? FUCK 'EM.
local ded = {MT_SMK_PIPE, MT_SMK_THWOMP}
for _,i in ipairs(ded) do
	addHook("MobjCollide", function(mo, mo2)
		if not hq_huge.value return end
		if not (mo and mo.valid) return end
		if not mo2.player return end
		if mo2.player
			if (mo2.player.huge > 0 or mo2.player.mo.sparkle > 0) and ((mo2.z <= mo.z + mo.height) and (mo2.z + mo2.height >= mo.z)) -- Height check
				P_KillMobj(mo, mo2, mo2)
			end
		end
	end, i)
end

--Eggbomb Fix--
local function noeggroll (mo, mo2)
	if mo2.player
	and (mo2.player.huge > 0)
		if mo2.player.kartstuff[k_itemtype]
			return true
		else
			return false
		end
	end
	return
end
addHook("TouchSpecial", noeggroll, MT_EGGMANITEM)

--- Don't Stop Me Now --- 
local function hugeinv(p, inf, source)
	if p.huge > 0
	or p.mo.sparkle > 0
		if not p.powers[pw_flashing]
			if p.huge
				p.huge = max($-(2*TICRATE), 1)
			end
		
			if p.kartstuff[k_invincibilitytimer]
				p.mo.sparkle = max($-(2*TICRATE), 1)
			end

			S_StartSound(p.mo, sfx_s1ac)
			S_StartSound(p.mo, sfx_s1ac)
			S_StartSound(p.mo, sfx_s1ac)
		
			p.powers[pw_flashing] = TICRATE/2
		end
		return false
	end
	return
end

local function hqtank(p)
	if p.huge > 0
	or p.mo.sparkle > 0
		if not p.powers[pw_flashing]
			if p.huge
				p.huge = max($-(3*TICRATE), 1)
			end
		
			if p.kartstuff[k_invincibilitytimer]
				p.mo.sparkle = max($-(3*TICRATE), 1)
			end

			S_StartSound(p.mo, sfx_s1ac)
			S_StartSound(p.mo, sfx_s1ac)
			S_StartSound(p.mo, sfx_s1ac)
			p.powers[pw_flashing] = TICRATE/2
		end
		return false
	end
	return
end

local function HQ_WallHit(p)
	if p.mo.eflags & MFE_JUSTBOUNCEDWALL
		if (p.huge > 0 or p.mo.sparkle > 0)
		and not p.powers[pw_flashing]
			if p.huge
				p.huge = max($-(TICRATE), 1)
			end
		
			if p.kartstuff[k_invincibilitytimer]
				p.mo.sparkle = max($-(TICRATE), 1)
			end
			S_StartSound(p.mo, sfx_s1ac)
			S_StartSound(p.mo, sfx_s1ac)
			S_StartSound(p.mo, sfx_s1ac)
			p.powers[pw_flashing] = TICRATE/2
		end
	end
end
---Bless Togen for these Hooks---
addHook("ShouldDamage", function(mo, inflictor, source, damage)
    if not (mo and mo.valid and mo.player) then return end
	local mop, mopks = mo.player, mo.player.kartstuff
	
    if damage < 10000 then
		if mop.huge > 0
		or mop.kartstuff[k_invincibilitytimer] > 0
			if inflictor and inflictor.valid
				if ((inflictor.type == MT_ORBINAUT) 
				or (inflictor.type == MT_ORBINAUT_SHIELD) 
				or (inflictor.type == MT_JAWZ) 
				or (inflictor.type == MT_JAWZ_DUD) 
				or (inflictor.type == MT_JAWZ_SHIELD))
					mo.momx = 0
					mo.momy = 0
				end
				if not mop.powers[pw_flashing] then
					if mop.huge
						mop.huge = max($-(2*TICRATE), 1)
					end
					
					if mo.sparkle
						mo.sparkle = max($-(2*TICRATE), 1)
					end
					S_StartSound(mo, sfx_s1ac)
					S_StartSound(mo, sfx_s1ac)
					S_StartSound(mo, sfx_s1ac)
					mop.powers[pw_flashing] = TICRATE/2
					return false
				end
			end
		end
	elseif damage >= 10000 -- Sink stuff
		if HQ_SuperCheck(mop)
			if (inflictor and inflictor.type == MT_SINK)
				if (source and source.player)
					if not (CV_FindVar("kmp_respawnpoints") and CV_FindVar("kmp_respawnpoints").value) then
						if P_IsObjectOnGround(source.player.mo) then
							local x,y,z = source.player.mo.x, source.player.mo.y, source.player.mo.z
							local ang = source.player.mo.angle
							source.player.hqrespawn = {x, y, z, ang, source.player.mo.eflags & MFE_VERTICALFLIP}
						end
					end
					S_StartSound(source.player.mo, sfx_toada)
					P_DamageMobj(source.player.mo, MT_SINK, mo, 10000) -- NO U
					if (server) then
						local name = source.player.name
						local hqsuper = mop.name
COM_BufInsertText(server, "csay "..name.."\\tried throwing a kitchen sink at \\Super "..hqsuper..".")
					end
					return false
				end
			end
		end
	end
	return
end)
addHook("ShouldExplode", hqtank)
addHook("ShouldSpin", hugeinv)
addHook("ShouldSquish", hugeinv)


---Item Size Scaling; shoutouts to Titou's Comet weather---
local bigitem = {MT_BANANA, MT_ORBINAUT, MT_JAWZ, MT_JAWZ_DUD, MT_SSMINE, MT_SSMINE_SHIELD, MT_BALLHOG, MT_SINK}
for _,i in ipairs(bigitem) do
	addHook("MobjThinker", function(mo)
		if (not hq_huge.value) or (not mo and mo.valid) then return end
		
		if mo.target and mo.target.player and not mo.beeg
			mo.beeg = 1	
			if (mo.target.player.huge)
				mo.scale = (2*mapobjectscale)
			end
		end
		
		if mo.scale == (mapobjectscale*2) then
			local addx = FixedMul(mo.momx, mapobjectscale/2)
			local addy = FixedMul(mo.momy, mapobjectscale/2)
			P_TryMove(mo, (mo.x + addx), (mo.y + addy), mo.z, false)		
			//debug
			//if mo.type == MT_ORBINAUT and not mo.glass
				//mo.health = 1
				//mo.glass = true
			//end
		end
	end, i)
end

---Extended Spinout (from Benji)---
local function K_HQBonk (p)
	if (hq_huge.value) then
		if p.kartstuff[k_spinouttimer] 
			if p.hqspeen 
				p.kartstuff[k_spinouttimer] = $*5/4 //+25%
				p.hqspeen = false
			elseif p.hqboom
				p.kartstuff[k_spinouttimer] = $*3/2 //+50%
				p.mo.momz = $*3/2
				p.hqboom = false
			end
		end
	end

	if p.kartstuff[k_spinouttimer]
		if p.hqspb
			if p.kartstuff[k_spinouttimer]
				if p.kartstuff[k_eggmanexplode]
				or p.kartstuff[k_roulettetype] == 2
					p.kartstuff[k_spinouttimer] = $*3/2 //+50%
					p.mo.momz = $*3/2 //+50%
					K_StripOther(p)
					//print("FUCK YOU")
				end
			end
			p.hqspb = false
		end
	end
end

---The Big Ones---
local function ohhhhbanana (mo)
	local x = mo.x
	local y = mo.y
	local z = mo.z
	local banan = FixedMul(5*FRACUNIT, mo.scale)
	local boffset = FixedMul(FRACUNIT, mo.scale)
	if mo.scale >= (2*mapobjectscale)
	and ((not (cv_weathermod)) or ((cv_weathermod) and ((weathermod.current.id ~= 22) or (weathermod.current.id == 22) and (weathermod.active == false))))
		//print("OHHHH BANANA")
		local split1 = P_SpawnMobj(x, y, z+boffset, MT_BANANA)
		split1.potassium = true
		split1.owner = mo.owner
		//split1.momx = FRACUNIT*cos(mo.angle-ANGLE_135)
		split1.momy = FixedMul(banan, cos(mo.angle))
		split1.momz = FixedMul(banan, sin(ANGLE_45))
		local split2 = P_SpawnMobj(x, y, z+boffset, MT_BANANA)
		split2.potassium = true
		split2.owner = mo.owner
		split2.momx = FixedMul(-banan, cos(mo.angle))
		//split2.momy = FRACUNIT*sin(mo.angle+ANGLE_135)
		split2.momz = FixedMul(banan, sin(ANGLE_45))
		local split3 = P_SpawnMobj(x, y, z+boffset, MT_BANANA)
		split3.potassium = true
		split3.owner = mo.owner
		split3.momx = FixedMul(banan, cos(mo.angle))
		//split3.momy = FixedMul(FixedMul(banan, sin(mo.angle)), cos(ANGLE_45))
		split3.momz = FixedMul(banan, sin(ANGLE_45))
	end
end
addHook("MobjDeath", ohhhhbanana, MT_BANANA)

local function PraiseBeToBanan(mo)
	if not mo and mo.potassium return end
	if mo.potassium == true
		if not P_IsObjectOnGround(mo)
			mo.flags = $ | MF_NOCLIPTHING
		else
			mo.flags = $ & ~MF_NOCLIPTHING
		end
	end
end
addHook("MobjThinker", PraiseBeToBanan, MT_BANANA)

//local function BananDebug(mo)
	//if not mo.potassium
		//mo.scale = 2*mapobjectscale
	//end
//end

//addHook("MobjThinker", BananDebug, MT_BANANA)

--local balltimer = TICRATE/5
--local split1
--local split2
--local split3
--local split4

local function pinball (mo)
	local x = mo.x
	local y = mo.y
	local z = mo.z
	local dis = 40
	local ball = FixedMul((dis*FRACUNIT), mo.scale)
	local balldiff = FixedMul(((2*dis)*FRACUNIT), mo.scale)
	local angdiff = ANGLE_45
	local hqspawn = 0
	if mo.scale >= (2*mapobjectscale)
	and ((not (cv_weathermod)) or ((cv_weathermod) and ((weathermod.current.id ~= 22) or (weathermod.current.id == 22) and (weathermod.active == false))))
		while hqspawn < 2 -- Thank you micenice
		do
			local split = P_SpawnMobj(x+FixedMul((ball-(balldiff*hqspawn)), cos(mo.angle)), y-FixedMul((ball-(balldiff*hqspawn)), sin(mo.angle)), z, MT_ORBINAUT)
			split.movefactor = 64*mapobjectscale
			split.target = mo.target
			P_InstaThrust(split, (mo.angle+(-ANGLE_22h+(angdiff*hqspawn))), split.movefactor)
			split.bouncy = true
			split.beeg = 1
			hqspawn = $+1
		end
	end
end
addHook("MobjDeath", pinball, MT_ORBINAUT)

local function HQ_Superball(mo)
	if not (mo and mo.valid) then return end
	if not mo.bouncy then return end
	if P_IsObjectOnGround(mo) then
		mo.momz = FixedMul((30*FRACUNIT), mapobjectscale)
	end
end
addHook("MobjThinker", HQ_Superball, MT_ORBINAUT)

local balls = {MT_ORBINAUT, MT_ORBINAUT_SHIELD}
for _,i in ipairs(balls) do
	addHook("MobjThinker", function(mo)
		if not (mo and mo.valid) then return end
		if not (mo.target and mo.target.valid and mo.target.player) then return end
	
		if mo.target and mo.target.player then
			local pmo = mo.target
			local p = mo.target.player
			if not mo.superglow then
				if HQ_SuperCheck(p)	
					mo.hqsuperglow = 1
				else
					mo.hqsuperglow = -1
				end
			end
		end
		
		if mo.hqsuperglow == 1 then
			mo.hqsupershift = 1
			mo.color = HQ_animSuper[7][mo.hqsupershift]
			if leveltime%5 == 0 then
				if mo.hqsupershift == #HQ_animSuper[7]
					mo.hqsupershift = 1
				else
					mo.hqsupershift = $ + 1
				end
			end
		elseif mo.hqsuperglow == -1 
		and not mo.hqcolorset then
			mo.color = mo.target.player.skincolor
			mo.hqcolorset = true
		end
	end, i)
end

local function CheckInvincibility(p)
	if p.kartstuff[k_roulettetype] 
	or p.kartstuff[k_stolentimer] 
	or p.kartstuff[k_spinouttimer] 
	or p.kartstuff[k_wipeoutslow]
		return true
	else
		return false
	end
end

local function K_Stardust(p)
	if not (hq_sparkle.value) then return end
	
	pks = p.kartstuff
	p.mo.sparkle = $ or 0
	p.mo.hqistacks = $ or 0
	local shiny = (12*TICRATE)+(TICRATE/2)
	//if leveltime > STARTTIME
	//	print("K_Stardust".." IT: "..pks[k_itemtype].." LFIT: "..p.HQLFitem.." IA: "..pks[k_itemamount].." LFIA: "..p.HQLFamount)
	//end

	if p.HQLFitem == 3
	and pks[k_itemamount] < p.HQLFamount
	and not CheckInvincibility(p) then
		//print("STAR POWER")
		if not (battleplus and G_BattleGametype()) -- No cheesing with stacked Invincibility either
			if p.mo.sparkle
			and p.mo.hqistacks >= 2 then
				p.mo.sparkle = (($ + shiny + 1)*3)/4
			else
				p.mo.sparkle = $ + (shiny + 1)
			end
			
			if hq_superform.value
			and p.huge > 0 then
				--print("SHAZAM")
				p.mo.sparkle = max(($ + p.huge)/2, 10*TICRATE)
				p.mo.sparkle = min($, 10*TICRATE)
				p.huge = p.mo.sparkle
			end
			
			p.mo.hqistacks = $+1
		end
	end
	
	if p.mo.sparkle > 0
		p.mo.sparkle = max($-(hq_ingame()/pks[k_position]), 1)
		pks[k_invincibilitytimer] = p.mo.sparkle
		//print("timer:"..p.mo.sparkle)
		
		if p.mo.sparkle == 1 then
			p.mo.sparkle = 0
		end
	end

	if not p.mo.sparkle
		p.mo.hqistacks = 0
	end
	
	if HQ_SuperCheck(p) then	-- Check for Super (InvinciGrow) state
		local spook = P_SpawnGhostMobj(p.mo)
		if hq_supercolor.value == -1 then
			if p.mo.skin == "sonic"
				spook.color = HQ_animSuper[0][p.hqsupershift]
			elseif (p.mo.skin == "tails" or p.mo.skin == "kuze")
				spook.color = HQ_animSuper[1][p.hqsupershift]
			elseif p.mo.skin == "knuckles"
				spook.color = HQ_animSuper[2][p.hqsupershift]
			elseif (p.mo.skin == "blaze" or p.mo.skin == "majima")
				spook.color = HQ_animSuper[3][p.hqsupershift]
			elseif (p.mo.skin == "gunvolt" or p.mo.skin == "copen")-- Anthem
				spook.color = HQ_animSuper[5][p.hqsupershift]
			elseif p.mo.skin == "kiryu"-- Heat Mode
				spook.color = HQ_animSuper[7][p.hqsupershift]
			else
				spook.color = HQ_animSuper[0][p.hqsupershift]
			end
		else
			spook.color = HQ_animSuper[hq_supercolor.value][p.hqsupershift]
		end
		spook.colorized = true
	else
		if not HQ_PowerTimerEnd(p) then
			if not (BoostFX) -- Boost FX isn't loaded
				if pks[k_invincibilitytimer] > 0
					local spook = P_SpawnGhostMobj(p.mo)
					if leveltime%(TICRATE/5) == 0
						p.mo.color = SKINCOLOR_WHITE
						spook.color = p.mo.color
						p.mo.colorized = true
						spook.colorized = true
					else
						p.mo.color = p.skincolor
						spook.color = p.mo.color
						p.mo.colorized = false
						spook.colorized = false
					end
				else
					if not (p.huge)
						p.mo.color = p.skincolor
						p.mo.colorized = false
					end
				end
			elseif (BoostFX and p.bfxflamecolor < 103) -- Boost FX is loaded
				if pks[k_invincibilitytimer] > 0
					local spook = P_SpawnGhostMobj(p.mo)
					if leveltime%(TICRATE/5) == 0
						p.mo.color = SKINCOLOR_WHITE
						spook.color = p.mo.color
						p.mo.colorized = true
						spook.colorized = true
					else
						p.mo.color = p.skincolor
						spook.color = p.mo.color
						p.mo.colorized = false
						spook.colorized = false
					end
				else
					if not (p.huge)
						p.mo.color = p.skincolor
						p.mo.colorized = false
					end
				end
			end
		end
	end
	p.HQLFitem = pks[k_itemtype]
	p.HQLFamount = pks[k_itemamount]
			
	if pks[k_spinouttimer] > 0
	or pks[k_wipeoutslow] > 0
		p.mo.sparkle = 0
		pks[k_invincibilitytimer] = 0
		p.hqistacks = 0
	end
end

--- Sonic 1 throwback ---
local function classicsonic(mo)
	if not (mo and mo.valid) return end
	if (not hq_sparkle.value) then return end
	if not (mo.target and mo.target.valid) then return end
	local p = mo.target.player
	local pmo = mo.target
	if HQ_SuperCheck(p) then
		if hq_supercolor.value == -1 then
			if pmo.skin == "sonic"
				mo.color = HQ_animSuper[0][p.hqsupershift]
			elseif (pmo.skin == "tails" or pmo.skin == "kuze")
				mo.color = HQ_animSuper[1][p.hqsupershift]
			elseif pmo.skin == "knuckles"
				mo.color = HQ_animSuper[2][p.hqsupershift]
			elseif (pmo.skin == "blaze" or pmo.skin == "majima")
				mo.color = HQ_animSuper[3][p.hqsupershift]
			elseif (pmo.skin == "gunvolt" or pmo.skin == "copen")-- Anthem
				mo.color = HQ_animSuper[5][p.hqsupershift]
			elseif pmo.skin == "kiryu"-- Heat Mode
				mo.color = HQ_animSuper[7][p.hqsupershift]
			else
				mo.color = HQ_animSuper[0][p.hqsupershift]
			end
		else
			mo.color = HQ_animSuper[hq_supercolor.value][p.hqsupershift]
		end
		mo.colorized = true
	else
		if p.kartstuff[k_invincibilitytimer] >= 3*TICRATE then
			if not (BoostFX and p.bfxflamecolor >= 103)
				mo.color = SKINCOLOR_WHITE
				mo.colorized = true
			end
		elseif (p.kartstuff[k_invincibilitytimer] > 0
		and p.kartstuff[k_invincibilitytimer] < 3*TICRATE) then
			mo.color = SKINCOLOR_RED
			mo.colorized = true
		end
	end
end
addHook("MobjThinker", classicsonic, MT_SPARKLETRAIL)


local function HQ_InvTrailBGone(mo)
	if not (mo and mo.valid) then return end
	if mo.target and mo.target.player then
		print(mo.target.player.name)
		if mo.target.player.kartstuff[k_invincibilitytimer] > 0
		or HQ_SuperCheck(mo.target.player) then
			if mo.color ~= mo.target.color
				P_KillMobj(mo, nil, nil)
			end
		end
	end
end
addHook("MobjThinker", HQ_InvTrailBGone, MT_GHOST)

---We don't waste MT in this house--
local function K_DriftboostJump(p)
	if not (hq_mtstore.value) then return end
	
	pks = p.kartstuff
	
	if pks[k_driftboost] > 0
		//print("DriftBoost:"..pks[k_driftboost])
		if ((not P_IsObjectOnGround(p.mo))
        or (not acrobatics and pks[k_sneakertimer])
        or (acrobatics and pks[k_sneakertimer] > 0 and p.tricksneakerbuffer > 0))
		and p.playerstate == PST_LIVE
			pks[k_driftboost] = $+1
		end
	end
end


local function K_HQNyoom(mo)
	if not (hq_mtstore.value) or not (mo and mo.valid) then return end
	if not (mo.target and mo.target.valid) then return end
	
	if mo.target and mo.target.player then
        if mo.target.player.kartstuff[k_driftboost] > 0
        and ((not acrobatics and mo.target.player.kartstuff[k_sneakertimer] > 0)
        or (acrobatics and mo.target.player.kartstuff[k_sneakertimer] > 0 and mo.target.player.tricksneakerbuffer > 0))
			mo.color = SKINCOLOR_HANDHELD
			mo.colorized = true
		else
			if not mo.target.player.bfxlinecolor
				mo.colorized = false
			end
		end
	end
end
addHook("MobjThinker", K_HQNyoom, MT_FASTLINE)

--LOOK ALIVE (from Benji)--
local sfxnum, localplayer = 0, nil
local function STOPTHIS(p, this)
	if (sfxnum != this and S_SoundPlaying(p.mo, this)) then
		S_StopSoundByID(p.mo, this)
	end
end
local function UpdateGrowAlarmSound(p)
	if not (hq_huge.value) then return end
	
	if p.mo.health > 0 and p.huge > 0 and localplayer != p 
	and p.kartstuff[k_invincibilitytimer] == 0 //Prioritize Grow
		if (CV_FindVar("kartinvinsfx").value)
			sfxnum = sfx_hqa
		else
			sfxnum = sfx_hq
		end
	else
		sfxnum = 0
	end
	if (sfxnum != 0) and (not S_SoundPlaying(p.mo, sfxnum))
		S_StartSound(p.mo, sfxnum)
		S_StartSound(p.mo, sfxnum)
	end
	STOPTHIS(p, sfx_hqa)
	STOPTHIS(p, sfx_hq)
end

local function HQ_BoostExtend(p)
	if p.kartstuff[k_floorboost] > 0 
	or p.mo.recharge then
		if p.huge > 0
			p.huge = $+5
		end
		
		if p.mo.sparkle > 0
			p.mo.sparkle = $+5
		end
	end
end

-- So... You've just been ratio'd by a Super player
local function HQ_Respawn(p)
	local mo = p.mo
	if p.kartstuff[k_respawn]
	and p.hqrespawn
	and not p.mo.hqrespawned then
		local srs = p.hqrespawn
		local gooddrop = true
		
		local post = P_SpawnMobj(srs[1], srs[2], srs[3], MT_GARGOYLE)
		post.flags = MF_RUNSPAWNFUNC
		post.flags2 = $|MF2_DONTDRAW
		if srs[5] then
			post.eflags = $|MFE_VERTICALFLIP
			if P_GetMobjGravity(drop) < 0 then
				post.eflags = $|MFE_OBJECTFLIP
			end
		end
		
		local cx, cy, cz = mo.x, mo.y, mo.z
		local jz = post.z +128*mapobjectscale*P_MobjFlip(post)

		P_MoveOrigin(mo, srs[1], srs[2], jz)
		if P_PlayerTouchingSectorSpecial(mo.player, 3, 2) then
			gooddrop = nil
		end
		
		P_MoveOrigin(mo, cx, cy, cz)

		if gooddrop then
			P_MoveOrigin(mo, srs[1], srs[2], srs[3])
			mo.angle = srs[4]
			if srs[5]
				mo.eflags = $|MFE_VERTICALFLIP
				if P_GetMobjGravity(mo) < 0
					mo.flags2 = $|MF2_OBJECTFLIP
				end
			end
			mo.z = $ + 128*mapobjectscale*P_MobjFlip(mo)
		end
		p.hqrespawn = nil
		p.mo.hqrespawned = true
	end
end
---HUGE QUEST---
addHook("MapLoad", do
	//for p in players.iterate
	//	hq_refresh(p)
	//end
end)

addHook("ThinkFrame", function()
	if leveltime == 0 then return end
	for p in players.iterate
		//if not (p.hqready) then
		//	hq_init(p)
		//	p.hqready = true
		//end

		if not (p.mo and p.mo.valid) then continue end
		if leveltime <= STARTTIME then continue end

		-- Player stuff
		K_DriftboostJump(p)
		K_HugeQuest(p)
		K_HQBonk(p)
		K_Stardust(p)
		HQ_WallHit(p)
		HQ_BoostExtend(p)
		HQ_Respawn(p)
		
		if hq_debug.value
			if HQ_SuperCheck(p) then
				p.huge = max($, (10*TICRATE))
				p.mo.sparkle = max($, (10*TICRATE))
			end
			
			if p.kartstuff[k_itemblink] == TICRATE
				if HQ_SuperCheck(p) then
					if p.kartstuff[k_itemtype] ~= 6 then
						p.kartstuff[k_itemtype] = 6
					end
				else
					if p.huge > 0
						if p.kartstuff[k_itemtype] ~= 3 then
							p.kartstuff[k_itemtype] = 3
						end
					else
						if p.kartstuff[k_itemtype] ~= 11 then
							p.kartstuff[k_itemtype] = 11
						end
					end
				end
			end
			--if p.huge > 0 then
				--print("Huge: "..buildTimeString(p.huge))
			--end

			--if p.mo.sparkle > 0
				--print("Sparkle: "..buildTimeString(p.mo.sparkle))
			--end
		end
		
		HQ_PowerEnd(p)
		UpdateGrowAlarmSound(p)
		
		if HOSTMOD then
			if p.huge > 0 and p.huge <= 3*TICRATE
				local r = p.huge / TICRATE + 1
				local d = r*2 + 1
				if (CV_FindVar("powerflash").value) then
					if (leveltime % d < r) and (CV_FindVar("powerflash").value)
						if hq_offroad.value
							p.mo.color = SKINCOLOR_YELLOW
						else
							p.mo.color = SKINCOLOR_PERIWINKLE
						end
						p.mo.colorized = true
					else
						p.mo.color = p.skincolor
						p.mo.colorized = false
					end
				end
				if not (p.huge % TICRATE) and (CV_FindVar("powersound").value) then
					S_StartSound(nil, sfx_s242, p)
				end
			end
		end
	end
end)


---Hitfeed Support: Thank you Snu---
local function hqSquish(p, inflictor, source)
	if not (hq_huge.value) then return end

	if (inflictor and inflictor.player) then
		if (source and source.player)
			if source.player.huge > 0
			or source.player.mo.sparkle > 0
				if source.player.huge
					source.player.huge = $ + (2*TICRATE)
				end
					
				if source.player.mo.sparkle
					source.player.mo.sparkle = $ + (2*TICRATE)
				end
				S_StartSound(source, sfx_token, source.player)
			end
			
			if HQ_SuperCheck(source.player)
				if not (CV_FindVar("kmp_respawnpoints") and CV_FindVar("kmp_respawnpoints").value) then
					if P_IsObjectOnGround(p.mo) then
						local x,y,z = p.mo.x, p.mo.y, p.mo.z
						local ang = p.mo.angle
						p.hqrespawn = {x, y, z, ang, p.mo.eflags & MFE_VERTICALFLIP}
					end
				end
				if fd_loaded then
					if p.preferredDeath ~= 5 then
						p.hqstoreddeath = $ or 0
						p.hqstoreddeath = p.preferredDeath
						p.preferredDeath = 5
						applyFunnyDeath(p)
						S_StartSound(p.mo, sfx_toada)
						P_DamageMobj(p.mo, nil, nil, 10000)
						p.preferredDeath = p.hqstoreddeath
					end
				else
					p.mo.flags2 = $|MF2_DONTDRAW
					S_StartSound(p.mo, sfx_toada)
					P_DamageMobj(p.mo, nil, nil, 10000)
				end
			end
		end
	end
	if (hitfeed)
		if not (source and source.player) return end
		if not (p.mo and p.mo.valid) return end
		if inflictor.player then
			if source.player.huge > 0
				local s_hq = {{source.player.name, source.hf_overridenamecolor or source.player.skincolor}, {skins[source.skin].facemmap, source.player.skincolor}, source.player}
				local v_hq = {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
				if (s_hq[3] == v_hq[3]) then source = nil end	-- source == victim, remove source
				local icon_hq = "K_HMGROW"
				
				if HQ_SuperCheck(source.player)
					if not HF_animIcon["K_HQSUP"] then HF_animIcon["K_HQSUP"] = {2,2} end
					icon_hq = "K_HQSUP"
				end

				HF_SendHitMessage(s_hq, v_hq, icon_hq)
			end
		end
	end
end
addHook("PlayerSquish", hqSquish)

local function HQ_Superdeath(mo, i, s)
	if not (mo and mo.valid) then return end
	if not (mo and mo.player) then return end
	
	if i and i.valid then
		if i.type == MT_PLAYER then
			if s and s.player then
				if HQ_SuperCheck(s.player) then
					mo.flags2 = $|MF2_DONTDRAW
				end
			end
		end
	end
end
addHook("MobjDeath", HQ_Superdeath, MT_PLAYER)
---YEET (from Benji)---
addHook("PlayerSpin", function(p, inf, source)
	if not (inf and inf.valid) or not (hq_huge.value) then return end
	
	if inf.scale == (mapobjectscale*2) 
	and ((inf.type == MT_ORBINAUT) 							
	or (inf.type == MT_ORBINAUT_SHIELD) 
	or (inf.type == MT_JAWZ) 
	or (inf.type == MT_JAWZ_DUD) 
	or (inf.type == MT_JAWZ_SHIELD)
	or (inf.type == MT_BANANA) 
	or (inf.type == MT_BANANA_SHIELD) 
	or (inf.type == MT_BALLHOG))
		//print("ow")
		p.hqspeen = true
	end
	
	-- Grow/Sparkle extension
	if ((inf.type == MT_ORBINAUT) 							
	or (inf.type == MT_ORBINAUT_SHIELD) 
	or (inf.type == MT_JAWZ) 
	or (inf.type == MT_JAWZ_DUD) 
	or (inf.type == MT_JAWZ_SHIELD)
	or (inf.type == MT_BANANA) 
	or (inf.type == MT_BANANA_SHIELD) 
	or (inf.type == MT_BALLHOG))
		if source and source.player
			if source.player.huge > 0
			or source.player.mo.sparkle > 0
				if source.player.huge
					source.player.huge = $ + TICRATE
				end
					
				if source.player.mo.sparkle
					source.player.mo.sparkle = $ + TICRATE
				end
				S_StartSound(source, sfx_token, source.player)
			end
		end
	elseif (inf.type == MT_PLAYER)
		if source and source.player
			if source.player.huge > 0
			or source.player.mo.sparkle > 0
				if source.player.huge
					source.player.huge = $ + (2*TICRATE)
				end
					
				if source.player.mo.sparkle
					source.player.mo.sparkle = $ + (2*TICRATE)
				end
				S_StartSound(source, sfx_token, source.player)
			end
		end
	end
end)
addHook("PlayerExplode", function(p, inf, source)
	if not (inf and inf.valid) then return end
	
	if hq_huge.value
		if inf.scale == (mapobjectscale*2) and ((inf.type == MT_SSMINE) or (inf.type == MT_SSMINE_SHIELD) or (inf.type == MT_MINEEXPLOSION))
			//print("ow")
			p.hqboom = true
		end
		
		--Grow/Sparkle extension
		if ((inf.type == MT_SSMINE) or (inf.type == MT_SSMINE_SHIELD) or (inf.type == MT_MINEEXPLOSION) or (inf.type == MT_SPBEXPLOSION))
			if source and source.player
				if source.player.huge > 0
				or source.player.mo.sparkle > 0
					if source.player.huge
						source.player.huge = $ + TICRATE
					end
					
					if source.player.mo.sparkle
						source.player.mo.sparkle = $ + TICRATE
					end
					S_StartSound(source, sfx_token, source.player)
				end
			end
		end
	end
	
	if (inf.type == MT_SPBEXPLOSION and inf.extravalue1)
		p.hqspb = true
	end
end)

hud.add(function(v, p, c)
	localplayer = p
end)